import { world, system, EquipmentSlot, ItemStack } from "@minecraft/server";

// Lore Prep

import './guidebook.js'

let CloakLorePrep = [
    '\n§r§5When Worn:',
    '\n§r§5Notes:',
    '§r§9+ Durability will gradually decrease over time.\n+ Can be augmented for infinite durability.',
    '§r§6Slot: §eChest',
    '\n§r§9Durability:',
    '\n§r§8Not Augmented',
    ''
]

let CloakLorePrepEmpty = ''

// LORE
class loreItem {
    constructor(itemId, lore) {
        this.itemId = itemId;
        this.lore = lore;
    }
}

const ItemArray = [
    new loreItem("darkw_pc:cloak_resistance_amp1", [CloakLorePrep[0], '§r§cSlowness IV (5:00)\n§r§7Resistance III (5:00)', CloakLorePrep[1], CloakLorePrep[2], CloakLorePrep[3], CloakLorePrep[4], '§r§91500 / 1500\nRepairable with Mantle Fabric', CloakLorePrep[5]]),
    new loreItem("darkw_pc:cloak_resistance_amp2", [CloakLorePrep[0], '§r§cSlowness VI (5:00)\n§r§7Resistance IV (5:00)', CloakLorePrep[1], CloakLorePrep[2], CloakLorePrep[3], CloakLorePrep[4], '§r§91500 / 1500\nRepairable with Mantle Fabric', CloakLorePrep[5]]),
    new loreItem("darkw_pc:cloak_night_vision_amp1", [CloakLorePrep[0], '§r§7Night Vision (5:00)', CloakLorePrep[1], CloakLorePrep[2], CloakLorePrep[3], CloakLorePrep[4], '§r§91500 / 1500\nRepairable with Mantle Fabric', CloakLorePrep[5]]),
    new loreItem("darkw_pc:cloak_jump_boost_amp1", [CloakLorePrep[0], '§r§7Jump Boost I (5:00)', CloakLorePrep[1], CloakLorePrep[2], CloakLorePrep[3], CloakLorePrep[4], '§r§91500 / 1500\nRepairable with Mantle Fabric', CloakLorePrep[5]]),
    new loreItem("darkw_pc:cloak_jump_boost_amp2", [CloakLorePrep[0], '§r§7Jump Boost II (5:00)', CloakLorePrep[1], CloakLorePrep[2], CloakLorePrep[3], CloakLorePrep[4], '§r§91500 / 1500\nRepairable with Mantle Fabric', CloakLorePrep[5]]),
    new loreItem("darkw_pc:cloak_fire_resistance_amp1", [CloakLorePrep[0], '§r§7Fire Resistance (5:00)', CloakLorePrep[1], CloakLorePrep[2], CloakLorePrep[3], CloakLorePrep[4], '§r§91500 / 1500\nRepairable with Mantle Fabric', CloakLorePrep[5]]),
    new loreItem("darkw_pc:cloak_speed_amp1", [CloakLorePrep[0], '§r§7Speed I (5:00)', CloakLorePrep[1], CloakLorePrep[2], CloakLorePrep[3], CloakLorePrep[4], '§r§91500 / 1500\nRepairable with Mantle Fabric', CloakLorePrep[5]]),
    new loreItem("darkw_pc:cloak_speed_amp2", [CloakLorePrep[0], '§r§7Speed II (5:00)', CloakLorePrep[1], CloakLorePrep[2], CloakLorePrep[3], CloakLorePrep[4], '§r§91500 / 1500\nRepairable with Mantle Fabric', CloakLorePrep[5]]),
    new loreItem("darkw_pc:cloak_water_breathing_amp1", [CloakLorePrep[0], '§r§7Water Breathing (5:00)', CloakLorePrep[1], CloakLorePrep[2], CloakLorePrep[3], CloakLorePrep[4], '§r§91500 / 1500\nRepairable with Mantle Fabric', CloakLorePrep[5]]),
    new loreItem("darkw_pc:cloak_regeneration_amp1", [CloakLorePrep[0], '§r§7Regeneration (5:00)', CloakLorePrep[1], CloakLorePrep[2], CloakLorePrep[3], CloakLorePrep[4], '§r§91500 / 1500\nRepairable with Mantle Fabric', CloakLorePrep[5]]),
    new loreItem("darkw_pc:cloak_regeneration_amp2", [CloakLorePrep[0], '§r§7Regeneration (5:00)', CloakLorePrep[1], CloakLorePrep[2], CloakLorePrep[3], CloakLorePrep[4], '§r§91500 / 1500\nRepairable with Mantle Fabric', CloakLorePrep[5]]),
    new loreItem("darkw_pc:cloak_strength_amp1", [CloakLorePrep[0], '§r§7Strength I (5:00)', CloakLorePrep[1], CloakLorePrep[2], CloakLorePrep[3], CloakLorePrep[4], '§r§91500 / 1500\nRepairable with Mantle Fabric', CloakLorePrep[5]]),
    new loreItem("darkw_pc:cloak_strength_amp2", [CloakLorePrep[0], '§r§7Strength II (5:00)', CloakLorePrep[1], CloakLorePrep[2], CloakLorePrep[3], CloakLorePrep[4], '§r§91500 / 1500\nRepairable with Mantle Fabric', CloakLorePrep[5]]),
    new loreItem("darkw_pc:cloak_slow_falling_amp1", [CloakLorePrep[0], '§r§7Slow Falling (5:00)', CloakLorePrep[1], CloakLorePrep[2], CloakLorePrep[3], CloakLorePrep[4], '§r§91500 / 1500\nRepairable with Mantle Fabric', CloakLorePrep[5]]),
    new loreItem("darkw_pc:cloak_wind_charged_amp1", [CloakLorePrep[0], '§r§7+ Fling Targets forward on hit. (5:00)\n+ Launch nearby mobs when you jump. (5:00)', CloakLorePrep[1], CloakLorePrep[2], CloakLorePrep[3], CloakLorePrep[4], '§r§91500 / 1500\nRepairable with Mantle Fabric', CloakLorePrep[5]]),
    new loreItem("darkw_pc:cloak_instant_damage_amp1", ['\n§r§5When Entity Hit:', '§r§cInstant Damage I', CloakLorePrep[1], CloakLorePrep[2], CloakLorePrep[3], CloakLorePrep[4], '§r§91500 / 1500\nRepairable with Mantle Fabric', CloakLorePrep[5]]),
    new loreItem("darkw_pc:cloak_instant_damage_amp2", ['\n§r§5When Entity Hit:', '§r§cInstant Damage II', CloakLorePrep[1], CloakLorePrep[2], CloakLorePrep[3], CloakLorePrep[4], '§r§91500 / 1500\nRepairable with Mantle Fabric', CloakLorePrep[5]]),
    new loreItem("darkw_pc:cloak_poison_amp1", ['\n§r§5When Entity Hit:', '§r§cPoison I (0:45)', CloakLorePrep[1], CloakLorePrep[2], CloakLorePrep[3], CloakLorePrep[4], '§r§91500 / 1500\nRepairable with Mantle Fabric', CloakLorePrep[5]]),
    new loreItem("darkw_pc:cloak_poison_amp2", ['\n§r§5When Entity Hit:', '§r§cPoison II (0:20)', CloakLorePrep[1], CloakLorePrep[2], CloakLorePrep[3], CloakLorePrep[4], '§r§91500 / 1500\nRepairable with Mantle Fabric', CloakLorePrep[5]]),
    new loreItem("darkw_pc:cloak_weakness_amp1", ['\n§r§5When Entity Hit:', '§r§cWeakness (1:30)', CloakLorePrep[1], CloakLorePrep[2], CloakLorePrep[3], CloakLorePrep[4], '§r§91500 / 1500\nRepairable with Mantle Fabric', CloakLorePrep[5]]),
    new loreItem("darkw_pc:cloak_wither_amp2", ['\n§r§5When Entity Hit:', '§r§cWither II (0:40)', CloakLorePrep[1], CloakLorePrep[2], CloakLorePrep[3], CloakLorePrep[4], '§r§91500 / 1500\nRepairable with Mantle Fabric', CloakLorePrep[5]]),
    new loreItem("darkw_pc:cloak_instant_health_amp1", [CloakLorePrep[0], '§r§7Instant Health I (1:00)', CloakLorePrep[1], '§r§9+ Durability will gradually decrease over time.', CloakLorePrep[3], CloakLorePrep[4], '§r§9300 / 300\nRepairable with Mantle Fabric', '\n§r§8This mantle cannot be augmented.']),
    new loreItem("darkw_pc:cloak_instant_health_amp2", [CloakLorePrep[0], '§r§7Instant Health II (2:00)', CloakLorePrep[1], '§r§9+ Durability will gradually decrease over time.', CloakLorePrep[3], CloakLorePrep[4], '§r§9600 / 600\nRepairable with Mantle Fabric', '\n§r§8This mantle cannot be augmented.']),
    new loreItem("darkw_pc:mantle_fabric", ['§r§9+ Used to create mantles']),
    new loreItem("darkw_pc:unbreakable_mantle_upgrade", ['§r§9Mantle Upgrade', '\n§r§7Applies to:\n §r§9Mantles', '§r§7Instructions:\n §r§91. Equip the mantle you would like to upgrade\n §r§92. Hold this upgrade in your main hand.\n §r§93. Use the upgrade, text will appear telling you what happened.'])
]
system.runInterval(() => { // Lore Controls
    for (const player of world.getPlayers()) { // Gets all players
        const playerContainer = player.getComponent("inventory").container; //
        for (let i = 0; i < playerContainer.size; i++) {
            const item = playerContainer.getItem(i);
            const findLore = ItemArray.find(x => x.itemId == item?.typeId);
            const lore = item?.getLore();
            if (!findLore || !item?.amount || lore?.length != 0) continue;
            item.setLore(findLore.lore);
            playerContainer.setItem(i, item);
        }
        // Offhand

        const equippable = player.getComponent('equippable')
        const chestItem = player.getComponent('equippable').getEquipment('Chest')
        const offhandLore = ItemArray.find(x => x.itemId == chestItem?.typeId);
        const offhandlore = chestItem?.getLore();
        if (!offhandLore || !chestItem?.amount || offhandlore?.length != 0) continue;
        chestItem.setLore(offhandLore.lore);
        equippable.setEquipment(EquipmentSlot.Chest, chestItem);
    }
}, 1);

// WORKS
system.runInterval(() => {
    for (const players of world.getPlayers()) {
        const equippable = players.getComponent('equippable');
        const Chest = equippable.getEquipment('Chest');
        if (!equippable) return

        // If NO ITEM, Unmute
        if (!Chest) {
            if (players.hasTag('darkw_pc:mute_equip')) {
                players.removeTag('darkw_pc:mute_equip')

                // If Triggered with Night Vision manle, remove effect
                if (players.hasTag('darkw_pc:has_night_vision')) players.removeEffect('night_vision')
                if (players.hasTag('darkw_pc:has_night_vision')) players.removeTag('darkw_pc:has_night_vision')
            }
            return
        }
        // If Cloak, Mute
        const cloakTest = Chest.typeId.includes('cloak')
        if (cloakTest && !players.hasTag('darkw_pc:mute_equip')) {

            if (Chest.typeId.includes('night_vision')) players.addTag('darkw_pc:has_night_vision')

            players.addTag('darkw_pc:mute_equip')
        }
        // If Item, but not cloak, Unmute
        if (!cloakTest && players.hasTag('darkw_pc:mute_equip')) {
            players.removeTag('darkw_pc:mute_equip')

            // If Triggered with Night Vision manle, remove effect
            if (players.hasTag('darkw_pc:has_night_vision')) players.removeEffect('night_vision')
            if (players.hasTag('darkw_pc:has_night_vision')) players.removeTag('darkw_pc:has_night_vision')
        }

        // Get Lore, Durability, and Unbreaking Enchantment.
        let getLore = Chest.getLore()
        let durability = Chest.getComponent('durability')
        let gamemode = players.getGameMode()
        let unbreaking = Chest.getComponent('enchantable').getEnchantment('unbreaking')
        const breakitem = new ItemStack('air', 1)

        // If player has mantle equipped, do stuff fn
        if (Chest.typeId.includes('cloak')) {

            if (!getLore[7].includes('Unbreakable') && (gamemode === 'survival' || gamemode === 'adventure')) {
                let Tickdamage = 5

                // Take durability, raw.
                if (unbreaking == undefined) {
                    if (durability.damage + 5 >= durability.maxDurability) {
                        players.runCommand('/playsound random.break @s')
                        equippable.setEquipment(EquipmentSlot.Chest, breakitem)
                    }
                    if (durability.damage + 5 < durability.maxDurability) {
                        durability.damage += Tickdamage
                        Chest.setLore([getLore[0], getLore[1], getLore[2], getLore[3], getLore[4], getLore[5], `§r§9${durability.maxDurability} / ${durability.maxDurability - durability.damage}\nRepaired with Mantle Fabric`, getLore[7]])
                        equippable.setEquipment(EquipmentSlot.Chest, Chest)
                    }
                }
                // Take durability, unbreaking active.
                if (unbreaking != undefined) {
                    // Test Durability
                    if (durability.damage + 5 >= durability.maxDurability) {
                        players.runCommand('/playsound random.break @s')
                        equippable.setEquipment(EquipmentSlot.Chest, breakitem)

                    }
                    if (durability.damage + 5 < durability.maxDurability) {
                        durability.damage += Tickdamage - unbreaking.level
                        Chest.setLore([getLore[0], getLore[1], getLore[2], getLore[3], getLore[4], getLore[5], `§r§9${durability.maxDurability} / ${durability.maxDurability - durability.damage}\nRepaired with Mantle Fabric`, getLore[7]])
                        players.runCommand('/stopsound @s armor.equip_leather')
                        players.runCommand('/stopsound @s armor.equip_generic')
                        equippable.setEquipment(EquipmentSlot.Chest, Chest)
                    }
                }
                if (!unbreaking) return
            }

        }
    }
}, 20)

system.afterEvents.scriptEventReceive.subscribe(event => {
    if (event.id === 'darkw_pc:apply_unbreak_augment') {
        const player = event.sourceEntity

        const equippable = player.getComponent('equippable');
        const Chest = equippable.getEquipment('Chest');
        if (!equippable) return
        if (!Chest) {
            player.runCommand('/tellraw @s {"rawtext":[{"text":"§cNo mantle is equipped."}]}')
            player.runCommand('/playsound hit.stem @s ~ ~ ~')
            return
        }
        const getLore = Chest.getLore()
        const durability = Chest.getComponent('durability')
        const augmentblock = getLore[7].includes('cannot')

        // Fail if already augmented
        if (getLore[7].includes('Unbreakable')) {
            player.runCommand('/tellraw @s {"rawtext":[{"text":"§cThis mantle is already augmented."}]}')
            player.runCommand('/playsound hit.stem @s ~ ~ ~')
            return
        }
        // Fail if mantle is not augmentable
        if (augmentblock) {
            player.runCommand('/tellraw @s {"rawtext":[{"text":"§cYou cannot augment this mantle."}]}')
            player.runCommand('/playsound hit.stem @s ~ ~ ~')
            return
        }
        // Complete if no fails
        if (!augmentblock) {
            const mainHand = equippable.getEquipment('Mainhand')

            Chest.setLore([getLore[0], getLore[1], getLore[2], getLore[3], getLore[4], getLore[5], getLore[6], '\n§r§dUnbreakable'])
            durability.damage -= durability.damage
            equippable.setEquipment(EquipmentSlot.Chest, Chest)
            if (mainHand.amount == 1) {
                player.runCommand(`/replaceitem entity @s slot.weapon.mainhand 0 air`)
            }
            if (mainHand.amount > 1) {
                player.runCommand(`/replaceitem entity @s slot.weapon.mainhand 0 darkw_pc:unbreakable_mantle_upgrade ${mainHand.amount - 1}`)
            }

        }
    }
})

// Mantle Hits
world.afterEvents.entityHitEntity.subscribe(event => {
    if (event.damagingEntity.typeId === 'minecraft:player') {
        const player = event.damagingEntity
        const victim = event.hitEntity

        const equippable = player.getComponent('equippable');
        if (!equippable) return
        const Chest = equippable.getEquipment('Chest');

        if (!Chest) return

        switch (Chest.typeId) {
            // Instant Damage I
            case "darkw_pc:cloak_instant_damage_amp1": {
                victim.addEffect('instant_damage', 1, { amplifier: 1 })
                break
            }
            // Instant Damage II
            case "darkw_pc:cloak_instant_damage_amp2": {
                victim.addEffect('instant_damage', 1, { amplifier: 2 })
                break
            }
            // Poison Damage I
            case "darkw_pc:cloak_poison_amp1": {
                victim.addEffect('poison', 900, { amplifier: 1 })
                break
            }
            // Poison Damage II
            case "darkw_pc:cloak_poison_amp2": {
                victim.addEffect('poison', 180, { amplifier: 2 })
                break
            }
            // Weakness I
            case "darkw_pc:cloak_weakness_amp1": {
                victim.addEffect('weakness', 1800, { amplifier: 1 })
                break
            }
            // Wither II
            case "darkw_pc:cloak_wither_amp2": {
                victim.addEffect('wither', 800, { amplifier: 2 })
                break
            }
        }

        // WIND CHARGE
        try {
            if (Chest.typeId === 'darkw_pc:cloak_wind_charged_amp1') {
                const PlayerHeadRot = player.getViewDirection();
                const HPwr = Math.sqrt(PlayerHeadRot.x ** 2 + PlayerHeadRot.z ** 1.2) * 3;
                const Vpwr = PlayerHeadRot.y * 1.625;

                victim.dimension.spawnParticle('minecraft:wind_explosion_emitter', victim.location)
                victim.dimension.playSound('breeze_wind_charge.burst', victim.location)

                victim.applyKnockback(PlayerHeadRot.x, PlayerHeadRot.z, HPwr + 0.1, Vpwr + 0.35)
            }
        }
        catch { }
    }
})

world.afterEvents.playerButtonInput.subscribe(event => {
    const player = event.player
    const equippable = player.getComponent('equippable');
    if (!equippable) return
    const Chest = equippable.getEquipment('Chest');
    if (!Chest) return

    if (Chest.typeId === 'darkw_pc:cloak_wind_charged_amp1' && event.newButtonState === 'Pressed' && event.button === 'Jump') {
        const MantleOwner = player.nameTag
        if (!MantleOwner) return

        // Area Attack

        const x = player.location.x
        const y = player.location.y
        const z = player.location.z


        const mantleScan = player.dimension.getEntities({ maxDistance: 5, location: { x, y, z }, excludeNames: [MantleOwner], excludeTypes: ['minecraft:player', 'minecraft:item', 'minecraft:xp_orb'] })
        for (let s = 0; s < mantleScan.length; s++) {
            const mantleVictim = mantleScan[s]
            mantleVictim.applyKnockback(0, 0, 0, 0.75)
            mantleVictim.dimension.spawnParticle
                ('minecraft:wind_explosion_emitter', mantleVictim.location)
            mantleVictim.dimension.playSound('breeze_wind_charge.burst', mantleVictim.location)
        }
    }
})

world.afterEvents.itemUse.subscribe(event => {
    if (event.itemStack.typeId === 'darkw_pc:unbreakable_mantle_upgrade') {
        event.source.runCommand('scriptevent darkw_pc:apply_unbreak_augment')
    }
})