import { world, system } from "@minecraft/server";
import { ModalFormData, ActionFormData } from "@minecraft/server-ui"

system.afterEvents.scriptEventReceive.subscribe(event => {

    // Guide Book MAIN
    if (event.id === 'darkw_pc:guide_book_main') {
        const player = event.sourceEntity
        const GB_main = new ActionFormData

        GB_main.title('Mantles Mastery Guide')
        GB_main.body('Welcome to the Mantles Add-On! This pack adds 16 new mantles to your world for easy use of potion effects. The below sections contains how to craft the different mantles and what they do.\n\nTip: Most Items in this pack when placed in the inventory will generate a description and tell you what it does.')
        GB_main.button('Crafting: Basics', 'textures/darkw/pc/icons/ico_cra')
        GB_main.button('Crafting: Mantles', 'textures/darkw/pc/icons/ico_cra')
        GB_main.button('Mechanics', 'textures/darkw/pc/items/mantles/mantle_slow_falling')
        GB_main.button('Augments', 'textures/darkw/pc/items/mantle_upgrade')
        GB_main.show(player).then(r => {
            if (r.canceled) return

            switch (r.selection) {
                case 0: {
                    player.runCommand('scriptevent darkw_pc:guide_book_fabric')
                    break
                }
                case 1: {
                    player.runCommand('scriptevent darkw_pc:guide_book_mantles')
                    break
                }
                case 2: {
                    player.runCommand('scriptevent darkw_pc:guide_book_mechanics')
                    break
                }
                case 3: {
                    player.runCommand('scriptevent darkw_pc:guide_book_augments')
                    break
                }
            }
        })
    }
    if (event.id === 'darkw_pc:guide_book_fabric') {
        const player = event.sourceEntity
        const GB_main = new ActionFormData

        GB_main.title('Crafting: The Basics')
        GB_main.body(`In order to craft any mantle, you're going to need §l§aMantle Fabric§r. The crafting recipe is below.\n\n(Tip: This recipe is automatically unlocked when you load a world).\n\n§bA§r - Wool (Any Color)\n§aB§r - Iron Ingot\nX - Air\n\n§bA§r§aB§r§bA§r\n§aB§rX§aB§r\n§bA§r§aB§r§bA§r\n\n• This recipe will give you four pieces when crafted. \n• Having this material in your inventory will unlock the recipes for all of the different mantles.`)
        GB_main.button('Back', 'textures/darkw/pc/items/ico_book')
        GB_main.show(player).then(r => {
            if (r.canceled) return
            if (r.selection == 0) player.runCommand('scriptevent darkw_pc:guide_book_main')
        })
    }

    if (event.id === 'darkw_pc:guide_book_mantles') {
        const player = event.sourceEntity
        const GB_main = new ActionFormData

        GB_main.title('Crafting: Mantles')
        GB_main.body(`Here's the fun part.\n\nThe recipe for crafting mantles is the exact same across every single item. The only difference? The only thing you change is the potion effect you want. \n• (e.g: Want a §l§6Strength Mantle§r? put §l§6strength potions§r in the recipe, §7§lWeakness§r? put §7Weakness Potions§r).\n\n§aP§r - Potion of Choice \n§bC§r - Mantle Fabric \n§2L§r - Leather Chestplate\nX - Air\n\n§aPPP§r\n§bC§r§2L§r§bC§r\nX§bC§rX\n\nNote: \n§l§c•  You cannot mix and match potion times or amplifiers when crafting§r. \n•  For example, you cannot craft a strength mantle with one potion being Three Minutes (3:00) and another being Eight Minutes (8:00). they all have to be the same time and amplifier.`)
        GB_main.button('Back', 'textures/darkw/pc/items/ico_book')
        GB_main.show(player).then(r => {
            if (r.canceled) return
            if (r.selection == 0) player.runCommand('scriptevent darkw_pc:guide_book_main')
        })
    }
    if (event.id === 'darkw_pc:guide_book_mechanics') {
        const player = event.sourceEntity
        const GB_main = new ActionFormData

        GB_main.title('Mechanics')
        GB_main.body(`So, you've crafted a mantle. how do you use it? First things first, place the item in a slot in your inventory. The instructions will then pop up when you hover over it.\n\n• When Worn in your chest slot, mantles will give you a set potion effect for a certain amount of time.\n\n• The mantles durability will slowly drain over time, you can view the duribility by the vanilla durability bar or the number by looking at the item description.\nMantles can be enchanted with unbreaking to reduce the break time.\n\n• Mantles will break when durability reaches zero, but can be repaired with mantle fabric.`)
        GB_main.button('Back', 'textures/darkw/pc/items/ico_book')
        GB_main.show(player).then(r => {
            if (r.canceled) return
            if (r.selection == 0) player.runCommand('scriptevent darkw_pc:guide_book_main')
        })
    }
    if (event.id === 'darkw_pc:guide_book_augments') {
        const player = event.sourceEntity
        const GB_main = new ActionFormData

        GB_main.title('Augmentation')
        GB_main.body(`Want to keep your mantle around forever? no problem! Craft a §e§lUnbreakable Augment Upgrade§r to prevent your mantle from taking damage ever again!\n\n§aA - Mantle Fabric\n§cB - Netherite Ingot\n§bC - Netherite Template\n\n§aA§cB§aA\n§aA§bC§aA\n§fX§aA§fX\n\nWhen you craft the upgrade, you can make your mantle invincible by:\n\n§r• Equipping the mantle you would like to upgrade (Chest Slot)\n§r• Hold the upgrade in your main hand.\n§r• Use the upgrade, text will appear telling you what happened.\n`)
        GB_main.button('Back', 'textures/darkw/pc/items/ico_book')
        GB_main.show(player).then(r => {
            if (r.canceled) return
            if (r.selection == 0) player.runCommand('scriptevent darkw_pc:guide_book_main')
        })
    }
})

world.afterEvents.itemUse.subscribe(event => {
    if (event.itemStack.typeId === 'darkw_pc:guidebook') {
        event.source.runCommand('scriptevent darkw_pc:guide_book_main')
    }
})